stages:
  - setup
  - analysis
  - deployment

default:
  before_script:
    - source cicd_config/bash_scripts.sh;

create_delta:
  rules:
    - if: '$SKIP_CICD == "true"'
      when: never
    - if: '$CI_COMMIT_BRANCH == $PRE_BRANCH_NAME'
    - if: '$CI_COMMIT_BRANCH == $PROD_BRANCH_NAME'
    - if: '$CI_COMMIT_BRANCH == $BACK_BRANCH_NAME'
  stage: setup
  script:
    - delta_creation

auth:
  rules:
    - if: '$SKIP_CICD == "true"'
      when: never
    - if: '$CI_COMMIT_BRANCH == $PRE_BRANCH_NAME'
    - if: '$CI_COMMIT_BRANCH == $PROD_BRANCH_NAME'
    - if: '$CI_COMMIT_BRANCH == $BACK_BRANCH_NAME'
  stage: setup
  script:
  - auth_org

deploy:
  rules:
    - if: '$SKIP_CICD == "true"'
      when: never
    - if: '$CI_COMMIT_BRANCH == $PRE_BRANCH_NAME'
    - if: '$CI_COMMIT_BRANCH == $PROD_BRANCH_NAME'
    - if: '$CI_COMMIT_BRANCH == $BACK_BRANCH_NAME'
  stage: deployment
  needs: [create_delta, auth]
  script:
    - deploy